
var isDOM = (document.getElementById ? true : false);
var isIE4 = ((document.all && !isDOM) ? true : false);
var isNS4 = (document.layers ? true : false);
var isDyn = (isDOM || isIE4 || isNS4);

var deleteSubmit = false;

var viewModeQuestionPending = false;

function getPersistentRef(id)
{
  trace('getPersistentRef:begin');
  if (isDOM) return top.control.document.getElementById(id);
  if (isIE4) return top.control.document.all[id];
  if (isNS4) return top.control.document.layers[id];
  trace('getPersistentRef:end - never reached');
}
function getRef(id)
{
  trace('getRef:begin');
  if (isDOM) return document.getElementById(id);
  if (isIE4) return document.all[id];
  if (isNS4) return document.layers[id];
  trace('getRef:end - never reached');
}
function getRefFromFrame(frameRef, id)
{
  trace('getRefFromFrame:begin');
  if( frameRef != null ) {
    if (isDOM) return frameRef.document.getElementById(id);
    if (isIE4) return frameRef.document.all[id];
    if (isNS4) return frameRef.document.layers[id];
  }
  trace('getRefFromFrame:end - never reached');
}

// To work-around a bug in I.E. As usual, it doesn't follow
// the rules.  It doesn't process <button> tags correctly..
// If the button is this:
//    <button type=submit name=mybutton value=foo>bar</button>
// Then correct behavior is to send 'foo' as the value when clicked,
// But I.E. sends 'bar' (the visible display contents) instead.
// This routine is a workaround to fix that:
function buttonfix(){
  var buttons = document.getElementsByTagName('button');
  for (var i=0; i<buttons.length; i++) {
    buttons[i].onclick = function () {
      for(j=0; j<this.form.elements.length; j++)
	       if( this.form.elements[j].tagName == 'BUTTON' )
	         this.form.elements[j].disabled = true;
      this.disabled=false;
      this.style.overflow='hidden'; 
      this.style.visibility='hidden'; 
      this.style.display='none'; 
      this.value = this.attributes.getNamedItem('value').nodeValue ;
    }
  }
}
// Only do this for i.e. - others do not need this fix:
if( window != null ) {
  if( window.attachEvent != null ) {
    window.attachEvent('onload', buttonfix);
  }
}

var global_popup_window_handle = null;
function explainWindow( windWid, windHei, address, title ) {
  trace('explainWindow begins');
  theleft=(screen.width)?(screen.width-windWid)/2:100;
  thetop=(screen.height)?(screen.height-windHei)/2:100;
  theSettings='width=' + windWid + ',height=' + windHei + ',top=' + thetop + ',left=' + theleft + ',scrollbars=yes';
  trace('global_popup_window_handle = ' + (global_popup_window_handle==null ? 'null' : 'not null' ) );
  if( global_popup_window_handle != null &&
      typeof(  global_popup_window_handle ) != 'undefined' ) {

    // The following check is for Safari.  If a user manually closed the window, then the handle variable
    // now points to orphaned
    // data in Safari but not other browsers.  This check is to keep Safari from crashing if the variable
    // is no longer 'really there' because the user closed the window manually.
    if( ! global_popup_window_handle.closed )  { 

      global_popup_window_handle.close();

    } 
    global_popup_window_handle = null ;
  } 
  trace(' opening new global_popup_window_handle') ;
  global_popup_window_handle = window.open(address, title, theSettings);
  if(  global_popup_window_handle==null || 
       typeof(global_popup_window_handle)=="undefined") {
    newText = '<html><head><title>ADIT-NMR: Popup Block notify</title></head>\n' +
              '<body><h3>Help Popups are being Blocked</h3>\n' + 
              '<h4>Normally this help text would appear inside a pop-up window, but\n' +
              'your browser appears to have pop-up windows (windows created with window.open() )\n' +
              'disabled.</h4><hr>You can use this link as an alternate way to see the help text:\n'; 
    document.write( newText + '<a href="' + address + '" target="helpWindow">' + title + '</a>\n' + '</body><//html>\n' );
  } else {
    global_popup_window_handle.focus();
  }
}
var global_TracingOn = false; // Set to true to enable debug tracing 
function trace( msg ){
 if( global_TracingOn ) {
  if( typeof( jsTrace ) != 'undefined' ){
    jsTrace.send( msg );
  }
  else{
    alert( msg );
  }
 }
}

  // For updating most form input fields, this
  // function works (except for selects):
  function selectMoveToField( selfWidget, widget ) {
    trace( 'Inside selectMoveToField: Begin\n' );  
    if( widget != null ) {
      widget.value = "?";
      widget.value = selfWidget.options[selfWidget.selectedIndex].value;
      if( widget.value == "" ) { 
        widget.value = selfWidget.options[selfWidget.selectedIndex].text;
      }
    }
  }
  trace( 'Inside selectMoveToField: End\n' );  

  // For updating a select list, you have to use
  // this function:
  function fieldCopyToSelect( checkLabelToo, oldVal, widget, newVal ) {
    trace( 'Inside fieldCopyToSelect: Begin\n' );  
    var i = 0;
    var widgetText = "";
    var newValFound = 0;
    widget.selectedIndex = 0 // default if nothing found
    for( i=0 ; i < widget.options.length ; i++ ) {
      widgetText = widget.options[i].value;
      if( widgetText == "" ) {
        widgetText = widget.options[i].Text;
      }
      if( widgetText.toLowerCase == newVal.toLowerCase ) {
        newValFound = 1;
        break;
      }
      if( widgetText == "?" && newValFound == 0 ) {
        widget.selectedIndex = i;
      }
    }
    if( checkLabelToo ) {
      validateLabel( widget, oldVal );
    }
    trace( 'Inside fieldCopyToSelect: End\n' );  
  }

var posArray = new Array(4);  // Use to hold return coords(0-x, 1-y) from FindPosition 
var posx, posy; //Holds mouse position coords 
var disableBlur = false; // true to turn off event handler so onblur doesn't trigger when doing a change of focus

// Mouse button Down event method 
function InvokeSelect( textbox, listbox){ 
  trace( 'Inside InvokeSelect: Begin\n' );  
  var d = new Date();
  var now = d.getTime();
  if( listbox == null ) {
 trace( 'Inside InvokeSelect: End premature, listbox is null');  
    return;
  }
  if( listbox.lastBlurTime != null && (listbox.lastBlurTime + 250 > d.getTime() ) ) {
    // do nothing - too soon after the last blur of this listbox.
    // This is to prevent a case where you click on the textbox,
    // and it triggers both the listbox's onBlur and the textbox's onclick
    // in that case I only want to process one of those two things.
    trace( 'Inside InvokeSelect:   Too soon after lastblurtime');  
  } else {
    trace( 'Inside InvokeSelect: time window was long enough - doing the work.\n' );  
    if( listbox.style.visibility == 'hidden') { 
     trace( 'Inside InvokeSelect:   Hidden-to-Shown clause');  
    // make it become visible: 
      posArray=FindPosition(textbox); 
      trace( 'Inside InvokeSelect:   pos array = {'+posArray[0]+','+posArray[1]+','+posArray[2]+','+posArray[3]+'}');  
      listbox.style.position='absolute'; 
      // // listbox.style.left=posArray[0]-5; 
      listbox.style.left=posArray[0]+'px'; 
      listbox.style.top=posArray[3]+'px'; 
      // dummy test: listbox.style.left='20px'; 
      // dummy test: listbox.style.top='100px'; 
      listbox.style.overflow = 'auto';
      listbox.style.visibility='visible'; 
      listbox.style.display='inline'; 
      disableBlur = true;
      listbox.focus(); 
      disableBlur = false;
    } else { 
     trace( 'Inside InvokeSelect:   Shown-to-Hidden clause');  
      // Before switching focus, make sure the 'onblur' of the listbox
      // won't end up re-triggering this function.
      disableBlur = true;
      textbox.focus(); 
      // make it become hidden: 
      listbox.style.overflow = 'hidden';
      listbox.style.visibility='hidden'; 
      listbox.style.display='none';
    } 
  } 
 trace( 'Inside InvokeSelect: End');  
} 
function selectBoxKeyUp(e, listbox, textbox ) {
 trace( 'Inside selectBoxKeyUp: Begin');  
  if (!e) 
    var e=window.event; 
  if( e.keyCode == 13 || e.keyCode == 32 ) {
    AddToTextbox(listbox,textbox); 
    HideListBox(listbox, textbox ); 
    trace( 'Inside selectBoxKeyUp: END 1');  
    return true;
  } 
  if( e.keyCode == 8 || e.keyCode == 127 ) {
    HideListBox(listbox, textbox ); 
    trace( 'Inside selectBoxKeyUp: END 2');  
    return true;
  }
  trace( 'Inside selectBoxKeyUp: END 3');  
  return false;
} 
function selectBoxKeyDown(e, listbox, textbox ) {
   trace( 'Inside selectBoxKeyDown: Begin');  
  if (!e) 
    var e=window.event; 
  if( e.keyCode == 13 || e.keyCode == 32 ) {
    trace( 'Inside selectBoxKeyDown: END 1');  
    return true;
  } 
  if( e.keyCode == 8 || e.keyCode == 127 ) {
    trace( 'Inside selectBoxKeyDown: END 2');  
    return true;
  }
  trace( 'Inside selectBoxKeyDown: END 3');  
  return false;
} 
 
function selectBoxKeyPress(e, listbox, textbox ) {
  trace( 'Inside selectBoxKeyPress: Begin');  
  if (!e) 
    var e=window.event; 
  if( e.keyCode == 13 || e.keyCode == 32 ) {
    trace( 'Inside selectBoxKeyPress: END 1');  
    return true;
  } 
  if( e.keyCode == 8 || e.keyCode == 127 ) {
    trace( 'Inside selectBoxKeyPress: END 2');  
    return true;
  }
  trace( 'Inside selectBoxKeyPress: END 3');  
  return false;
} 
// Disable the backspace key - used in select inputs because
// without it, select lists do a back-arrow to previous page
// which is really, really dumb behavior since a user will think
// it's an input field and backspace will work normally.
function disableBS(e) {
  if (!e) 
    var e=window.event; 
  if( e.keyCode == 8 || e.keyCode == 127 ) {
    return false;
  } else {
    return true;
  }
}

// Key Down event, gets key character & hides listbox if visible 
function KeyDown(e, textbox, listbox){ 
 trace( 'Inside KeyDown: Begin');  
 var code; 
 if (!e) 
  var e=window.event; 
 if (e.keyCode) 
  code=e.keyCode; 
 else 
  if (e.which) 
   code = e.which; 
 // not used: var character = String.fromCharCode(code); 
 if( code == 40 ) { // 40 == down-arrow
   trace( 'Inside KeyDown:   down-arrow condition');  
    if( listbox.style.visibility == 'hidden') { 
    // make it become visible: 
      posArray=FindPosition(textbox); 
      listbox.style.position='absolute'; 
      // listbox.style.left=posArray[0]-5; 
      listbox.style.left=posArray[0]+'px'; 
      listbox.style.top=posArray[3]+'px'; 
      listbox.style.overflow='auto'; 
      listbox.style.visibility='visible'; 
      listbox.style.display='inline'; 
      disableBlur = true;
      listbox.focus(); 
      disableBlur = false;
    } 
 } 
 listbox.style.overflow='hidden'; 
 listbox.style.visibility='hidden'; 
 listbox.style.display='none'; 
 trace( 'Inside KeyDown: End');  
} 
 
// Find position of HTML element (el) 
function FindPosition(el){ 
 if(el.offsetParent){ 
  var inner_width = el.offsetWidth; 
  var inner_height = el.offsetHeight; 
  for( var posX=0, posY=0; 
       el.offsetParent; 
       el=el.offsetParent ) 
  { 
    posX+=el.offsetLeft; 
    posY+=el.offsetTop; 
  } 
  endX = posX + inner_width;
  endY = posY + inner_height;
  return [ posX, posY, endX, endY ]; 
 } 
 else 
  return [ el.x, el.y, el.x+el.width, el.y+el.height ]; 
} 
 
// Adds the selected listbox item to the textbox 
function AddToTextbox(listbox,textbox){ 
  trace( 'Inside AddToTextBox: Begin');  
  textbox.value=listbox[listbox.selectedIndex].value; 
  trace( 'Inside AddToTextBox: End');  
} 
 
// Adds the selected listbox item to the textbox 
function HideListBox(listbox, textfield ){ 
  trace( 'Inside HideListBox: Begin');  
  disableBlur = true;
  listbox.style.overflow='hidden'; 
  listbox.style.visibility='hidden'; 
  listbox.style.display='none'; 
  disableBlur = false;
  if( textfield != null ) {
    textfield.focus();
  }
  trace( 'Inside HideListBox: End');  
} 
function doBlur(listbox){
  trace( 'Inside doBlur: Begin');  
  if( disableBlur ){ 
    disableBlur = false;
  }
  else {
    HideListBox(listbox, null );
    var d = new Date();
    listbox.lastBlurTime = d.getTime();
  }
  trace( 'Inside doBlur: End');  
}

var contactHttpRequest;
var ajaxRequestURL = "http://" +  window.location.host + "/cgi-bin/bmrb-adit/get-live-data";

function getContactIfDirty( formInputField, rowNum )
{
  trace( 'Inside getContactIfDirty: Begin');  
  if( formInputField.getAttribute("isDirty") == "T" ) {

    contactHttpRequest = HttpRequestBrowserIndependant();
    if (!contactHttpRequest) {
      alert('getContactFromServer(): Cannot create an XMLHTTP instance.');
      return false;
    }
    contactHttpRequest.onreadystatechange = function() { hContactRequestStateChanged( contactHttpRequest, rowNum); };

    var ufid = getRef( "myHiddenUFID" ).getAttribute( "myUFID" );
    contactHttpRequest.open('GET',
		      ajaxRequestURL + "?" +
			"queryType=contact_email&" +
			"ufid=" + ufid + "&" +
			"arg1=" + formInputField.value ,
		      true);
    contactHttpRequest.send('');
    formInputField.setAttribute( "isDirty", "F" );
  } 
  trace( 'Inside getContactIfDirty: End');  
}

function certainlyBecomeDirty( formInputField ) {
  formInputField.setAttribute( "isDirty", "T" );
}

function maybeBecomeDirty( thisEvent, formInputField ) {
  trace( 'Inside maybeBecomeDirty: Begin');
  var curState = formInputField.getAttribute( "isDirty" );
  if( curState == "F" ) {
    if( !thisEvent ) {
      var thisEvent = window.event; 
    }
    var kCode;
    if (thisEvent.keyCode) 
     kCode=thisEvent.keyCode; 
    else 
     if (thisEvent.which) 
       kCode = thisEvent.which; 

    // keyCodes are not entirely browser-independant, but
    // for this (is it ascii) it should be good enough:
    // (This gets ctrl-U,ctrl-V,ctrl-W,ctrl-Z and all the ascii's above that.).
    // (I want ctrl-V to count since it's the paste button).
    if( kCode >= 20 ) {
      formInputField.setAttribute( "isDirty", "T" );
    } 
  } else {
  }
  trace( 'Inside maybeBecomeDirty: End' );
}

function hContactRequestStateChanged( hRequest, rowNum ) 
{
  trace( 'Inside hContactRequestStateChanged: Begin');  

   if( hRequest.readyState == 4 ) {
     if( hRequest.status == 200 ) {
       var xmlDoc = hRequest.responseXML;
       if( xmlDoc ) {
	 var cpBlock = xmlDoc.getElementsByTagName( "Contact_person" ).item(0);
	 if( cpBlock ) {

	   var val_EMail_address = cpBlock.getElementsByTagName( "Email_address" ).item(0).firstChild.data;
	   if( val_EMail_address == "?" || val_EMail_address == "." ) { val_EMail_address = ""; }

	   var val_Name_salutation = cpBlock.getElementsByTagName( "Name_salutation" ).item(0).firstChild.data;
	   if( val_Name_salutation == "?" || val_Name_salutation == "." ) { val_Name_salutation = ""; }

	   var val_Given_name = cpBlock.getElementsByTagName( "Given_name" ).item(0).firstChild.data;
	   if( val_Given_name == "?" || val_Given_name == "." ) { val_Given_name = ""; }

	   var val_Family_name = cpBlock.getElementsByTagName( "Family_name" ).item(0).firstChild.data;
	   if( val_Family_name == "?" || val_Family_name == "." ) { val_Family_name = ""; }

	   var val_Middle_initials = cpBlock.getElementsByTagName( "Middle_initials" ).item(0).firstChild.data;
	   if( val_Middle_initials == "?" || val_Middle_initials == "." ) { val_Middle_initials = ""; }

	   var val_Family_title = cpBlock.getElementsByTagName( "Family_title" ).item(0).firstChild.data;
	   if( val_Family_title == "?" || val_Family_title == "." ) { val_Family_title = ""; }

	   var val_Department_and_institution = cpBlock.getElementsByTagName( "Department_and_institution" ).item(0).firstChild.data;
	   if( val_Department_and_institution == "?" || val_Department_and_institution == "." ) { val_Department_and_institution = ""; }

	   var val_Mailing_address = cpBlock.getElementsByTagName( "Mailing_address" ).item(0).firstChild.data;
	   if( val_Mailing_address == "?" || val_Mailing_address == "." ) { val_Mailing_address = ""; }

	   var val_Address_1 = cpBlock.getElementsByTagName( "Address_1" ).item(0).firstChild.data;
	   if( val_Address_1 == "?" || val_Address_1 == "." ) { val_Address_1 = ""; }

	   var val_Address_2 = cpBlock.getElementsByTagName( "Address_2" ).item(0).firstChild.data;
	   if( val_Address_2 == "?" || val_Address_2 == "." ) { val_Address_2 = ""; }

	   var val_Address_3 = cpBlock.getElementsByTagName( "Address_3" ).item(0).firstChild.data;
	   if( val_Address_3 == "?" || val_Address_3 == "." ) { val_Address_3 = ""; }

	   var val_City = cpBlock.getElementsByTagName( "City" ).item(0).firstChild.data;
	   if( val_City == "?" || val_City == "." ) { val_City = ""; }

	   var val_State_province = cpBlock.getElementsByTagName( "State_province" ).item(0).firstChild.data;
	   if( val_State_province == "?" || val_State_province == "." ) { val_State_province = ""; }

	   var val_Country = cpBlock.getElementsByTagName( "Country" ).item(0).firstChild.data;
	   if( val_Country == "?" || val_Country == "." ) { val_Country = ""; }

	   var val_Postal_code = cpBlock.getElementsByTagName( "Postal_code" ).item(0).firstChild.data;
	   if( val_Postal_code == "?" || val_Postal_code == "." ) { val_Postal_code = ""; }

	   var val_Phone_number = cpBlock.getElementsByTagName( "Phone_number" ).item(0).firstChild.data;
	   if( val_Phone_number == "?" || val_Phone_number == "." ) { val_Phone_number = ""; }

	   var val_Fax_number = cpBlock.getElementsByTagName( "Fax_number" ).item(0).firstChild.data;
	   if( val_Fax_number == "?" || val_Fax_number == "." ) { val_Fax_number = ""; }

	   var val_Role = cpBlock.getElementsByTagName( "Role" ).item(0).firstChild.data;
	   if( val_Role == "?" || val_Role == "." ) { val_Role = ""; }

	   var val_Organization_type = cpBlock.getElementsByTagName( "Organization_type" ).item(0).firstChild.data;
	   if( val_Organization_type == "?" || val_Organization_type == "." ) { val_Organization_type = ""; }


	   var userOK = false;
	   if( false ) { // confirm dialog disabled for now:
	     var userOK = confirm( "::::::::::::::FOUND A MATCH:::::::::::::::::::\n" +
				   "A match was found for this e-mail address " +
				   "among the existing BMRB entries on the server.\n" +
				   "Do you want ADIT-NMR to populate the contact " +
				   "information using the data shown below " +
				   "for " + val_EMail_address + 
				   " (Name: " +
				   val_Name_salutation + " " +
				     val_Given_name + " " +
				       val_Middle_initials + " " +
					 val_Family_name + " " +
					   val_Family_title + " )?\n" +
				   "\n" +
				   "::::Department and Institution::::\n" +
				   val_Department_and_institution + "\n" +
				   "\n" +
				   "::::Address::::\n" +
				   val_Mailing_address + "\n" +
				     val_Address_1 + "\n" +
				       val_Address_2 + "\n" +
					 val_Address_3 + "\n" +
					   val_City + ", " +
					     val_State_province + " " +
					       val_Country + "\n" +
						 val_Postal_code + "\n" +
						   val_Phone_number + "\n" +
						     val_Fax_number + "\n" +
				   "\n" +
				   "Click \"OK\" to populate, or \"Cancel\" to leave unchanged."
				 );
	   } else {
	     userOK = true;
	   }

	   if( userOK ) {
	     setComplexInputFieldValue( "_Contact_person.Name_salutation", rowNum, val_Name_salutation, true );
	     setComplexInputFieldValue( "_Contact_person.Given_name", rowNum, val_Given_name, true );
	     setComplexInputFieldValue( "_Contact_person.Family_name", rowNum, val_Family_name, true );
	     setComplexInputFieldValue( "_Contact_person.Middle_initials", rowNum, val_Middle_initials, true );
	     setComplexInputFieldValue( "_Contact_person.Family_title", rowNum, val_Family_title, true );
	     setComplexInputFieldValue( "_Contact_person.Department_and_institution", rowNum, val_Department_and_institution, true );
	     setComplexInputFieldValue( "_Contact_person.Mailing_address", rowNum, val_Mailing_address, true );
	     setComplexInputFieldValue( "_Contact_person.Address_1", rowNum, val_Address_1, true );
	     setComplexInputFieldValue( "_Contact_person.Address_2", rowNum, val_Address_2, true );
	     setComplexInputFieldValue( "_Contact_person.Address_3", rowNum, val_Address_3, true );
	     setComplexInputFieldValue( "_Contact_person.City", rowNum, val_City, true );
	     setComplexInputFieldValue( "_Contact_person.State_province", rowNum, val_State_province, true );
	     setComplexInputFieldValue( "_Contact_person.Country", rowNum, val_Country, true );
	     setComplexInputFieldValue( "_Contact_person.Postal_code", rowNum, val_Postal_code, true );
	     setComplexInputFieldValue( "_Contact_person.Phone_number", rowNum, val_Phone_number, true );
	     setComplexInputFieldValue( "_Contact_person.FAX_number", rowNum, val_Fax_number, true );
	     //Comment-out: don't set Role:  setComplexInputFieldValue( "_Contact_person.Role", rowNum, val_Role, true );
	     setComplexInputFieldValue( "_Contact_person.Organization_type", rowNum, val_Organization_type, true );
	   }
	 }
       }
     } else {
       alert( 'Error with HTTPRequest: readyState = ' +
	      contactHttpRequest.readyState + 
	      ', status = ' + 
	      contactHttpRequest.status );
       return false;
     }
   }
  trace( 'Inside hRequestStateChanged: End');  
}

var percentHttpRequest;


// Prints the starting HTML text to define a percent bar - call this
// javascript right inside the HTML page at the point you want the
// percentage bar to appear.  DO NOT call it after the page is done
// loading  - that would make it start a new page.
function percentPrintInitialHTML( barID, /* Give it an id string that's unique,
					    so the program can refer to it */
                                  label,  /* HTML text to appear next to the progress bar */
                                  width,  /* Given in em's, not pixels */
				  borderColor, 
				  fgColor  /* Color to draw as it fills in */
				  /* (BG color is transparent) */
                                  )
{
  document.write( "<!-- Progress Bar Widget -->\n" );
  document.write( "  <div>\n" );
  document.write( "    " + label + "\n" );
  document.write( "  </div>\n" );
  document.write( "<div style='display:inline;'>\n" );
  document.write( "  <div style='border-width:0.2em; " +
                                "border-style:solid; " +
		  	        "border-color:" + borderColor + "; " +
				"width: " + width + "em; " +
			        "display:inline;' " +
		  "  >\n" );
  document.write( "    <div id='" + barID + "'\n" +
                  "         style='display:inline; " +
                                  "height=1em; " +
				  "width=0em; " +
				  "background-color: " + fgColor + "; " +
				  "'\n" +
		  "         fullWidth='" + width + "'\n" +
		  "    >\n" );
  document.write( "    </div>\n" );
  document.write( "  </div>\n" );
  document.write( "</div>\n" );
}

function percentBarNewVal( barID, ratio ) 
{
  theBarDiv = getRef( barID );
  if( theBarDiv != null ) {
    fullWidth = theBarDiv.getAttribute( "fullWidth" );
    if( fullWidth != null ) {
      curWidth = ( fullWidth * ratio ) ;
      theBarDiv.style.width = curWidth + "em";
    }
  }
}

function setComplexInputFieldValue( itemName, rowNum, newVal, doBlink )
{
  var inputID = getRef( itemName + "_" + rowNum ).getAttribute( "MyPName" );
  var altInputID = getRef( itemName + "_" + rowNum ).getAttribute( "MyPNameAlt" );
  var inputNode = getRef( inputID );
  var altInputNode = getRef( altInputID );

  // If this widget is a select list, then set it that way.
  // else just set the value field:
  if( inputNode.options != null ) {
    var oldVal = inputNode.value;
    fieldCopyToSelect( false, oldVal, inputNode, newVal );
  } else {
    inputNode.value = newVal;
  }

  // update the alt input too, if need be.
  if( altInputNode != null ) {
    if( altInputNode.options != null ) {
      var oldVal = altInputNode.value;
      fieldCopyToSelect( false, oldVal, altInputNode, newVal );
    } else {
      altInputNode.value = newVal;
    }
  }

  if( doBlink ) {
    // Set timers to do a quick little color fade
    var normalClassName = inputNode.ClassName;
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_1' );",    0 );
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_2' );",  100 );
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_3' );",  200 );
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_4' );",  300 );

    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_5' );",  400 );

    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_4' );",  600 );
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_3' );",  700 );
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_2' );",  800 );
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", 'input_field_fade_1' );",  900 );
    setTimeout( "setStyleClass( '"+itemName+"', "+rowNum+", '"+normalClassName+"' );",1000 );
  }

}
function setStyleClass( itemName, rowNum, newClassName )
{
  var curID = getRef( itemName + "_" + rowNum ).getAttribute( "MyPName" );
  var curNode = getRef( curID );
  var altInputID = getRef( itemName + "_" + rowNum ).getAttribute( "MyPNameAlt" );
  var altInputNode = getRef( altInputID );

  // Commented - out because I no longer walk up the node tree, instead I just change
  // the input cell itself.
  // Walk up the DOM parent tree until the containing <td> tag is found:
  // while( curNode != null && curNode.tagName != null && curNode.tagName.toLowerCase() != "td" ) {
  //   curNode = curNode.parentNode;
  // }
  // If a containing <td> tag was found, set its CSS class to the string given:
  if( curNode != null ) {
    curNode.className = newClassName;
  }
  if( altInputNode != null ) {
    altInputNode.className = newClassName;
  }
}

function HttpRequestBrowserIndependant()
{
  var returnHTTPRequest;

  if (window.XMLHttpRequest) { // Sane browsers
      returnHTTPRequest = new XMLHttpRequest();
      if( ! returnHTTPRequest ) {
	alert( 'javascript error trying to get new XMLHttpRequest object' );
      }
      if (returnHTTPRequest.overrideMimeType) {
	  returnHTTPRequest.overrideMimeType('text/xml');
	  // use text/html or text/xml for most applications.
      }
  } 
  else if (window.ActiveXObject) { // IE
    try {
      returnHTTPRequest = new ActiveXObject("Msxml2.XMLHTTP");
    } 
    catch (e) {
      try {
	returnHTTPRequest = new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e) {
      }
    }
  }
  return returnHTTPRequest;
}

// Ask if the user really wanted to delete the thingy described by the string
function confirmDelete( thingName )
{
  var displayName = thingName;
  if( displayName == '?' || displayName == '' ) {
    displayName = 'data on this page';
  }
  return confirm('Delete ' + displayName + '?\r\nAre you sure?\r\n');
}

// The function to call when submitting - performs a final check
// and returns true if submitting is okay, or false if it is not.
function submitValidate()
{
  var retVal = true;

  var ajaxPending;
  if( contactHttpRequest == null ) {
    ajaxPending = false;
  } else {
    ajaxPending = ( contactHttpRequest.readyState != 4 && contactHttpRequest.readyState != 0 );
  }

  retVal = ( ! ajaxPending );
  
  // If that's okay, then try another possible problem - the delete button was hit:
  if( retVal ) {
    if( deleteSubmit ) { // this is a variable set to true by the
                             // onclick of the delete button if the delete button
                             // was the manner in which this form was submitted.
      deleteSubmit = false;
      retVal = confirmDelete( "?" );
    }
  }

  if( retVal ) {
    if( viewModeQuestionPending ) {
      alert( "You must specify which type of deposition you are performing before continuing.\n" );
      retVal = false;
    }
  }
  // If that's okay then check if it's the form with the mandatory radio buttons.
  if( retVal ) {
    var failedToPick = false;
    var existingBMRBRef = getRef("fromExistingBMRBDiv");
    if( existingBMRBRef != null ) {
      var buttonsVisible = existingBMRBRef.style.display != 'none';

      if( buttonsVisible ) {
	var fromExistingBmrbFields = document.getElementsByName( "fromExistingBMRB" );
	var fromExistingBmrbVal = "";
	if( fromExistingBmrbFields != null && fromExistingBmrbFields.length > 0 ) {
	  failedToPick = true; // default if the fields exist until one that is checked is found.
	  for( var i = 0 ; i < fromExistingBmrbFields.length ; ++i ) {
	    if( fromExistingBmrbFields[i].checked ) {
	      failedToPick = false;
	      fromExistingBmrbVal = fromExistingBmrbFields[i].value;
	    }
	  }
	}
	if( failedToPick ) {
	  alert( "No answer was given for: 'Is this entry assciated with an already existing BMRB entry?'." );
	  retVal = false;
	}
	if( retVal && fromExistingBmrbVal == "yes" ) {
	  var existingBmrbValField = document.getElementsByName( "fromExistingBMRBNumber" );
	  var existingBmrbVal = parseInt( existingBmrbValField[0].value );
	  if( isNaN( existingBmrbVal ) || existingBmrbVal <= 0  ) {
	    alert( "The BMRB entry number you gave (" + existingBmrbVal + ") is not a positive integer." );
	    retVal = false;
	  }
	  if( retVal ) {
	    var prevBMRBOwnerFields = document.getElementsByName( "prevBMRBOwner" );
	    if( prevBMRBOwnerFields != null && prevBMRBOwnerFields.length > 0 ) {
	      failedToPick = true; // default if the fields exist until one that is checked is found.
	      for( var i = 0 ; i < prevBMRBOwnerFields.length ; ++i ) {
		if( prevBMRBOwnerFields[i].checked ) {
		  failedToPick = false;
		}
	      }
	    }
	    if( failedToPick ) {
	      alert( "No answer was given for: 'Is the BMRB entry yours?'." );
	      retVal = false;
	    }
	  }
	}
      }
    }
  }

  return retVal;
}

function enableAllSubmits()
{
  var allSubmits = document.getElementsByName( "SUBMIT" );
  var i;
  var thisSubmit;
  for( i = 0 ; i  < allSubmits.length ; i++ ) {
    thisSubmit = allSubmits[i];
    thisSubmit.style.display = 'inline';
  }
}

function viewModeHack( viewModeName )
{

  // (The viewModeID variable will be set elsewhere on the page).
  var viewModeInputArr = document.getElementsByName( viewModeName );
  var viewModeValue = '';
  if( viewModeInputArr ) {
    // Because it's a radio button we have to get the value this way
    // in Javascript:
    for( var i = 0 ; i < viewModeInputArr.length ; ++i ) {
      if( viewModeInputArr[i].checked ) {
	viewModeValue = viewModeInputArr[i].value;
      }
    }

    // If the value is PDB/BMRB then we need to ask a few more questions:
    var existingBMRBRef = getRef("fromExistingBMRBDiv");
    if( viewModeValue != null && viewModeValue != "" ) {
      viewModeQuestionPending = false;
    }
    if( viewModeValue == "PDB/BMRB" ) {
      if( existingBMRBRef ) {
	existingBMRBRef.style.display = 'block';
      }
    } else {
      if( existingBMRBRef ) {
	existingBMRBRef.style.display = 'none';
        var existingBMRBNumberRef = getRef( "fromExistingBMRBNumberDiv" );
	if( existingBMRBNumberRef ) {
	  existingBMRBNumberRef.style.display = 'none';
	}
	// reset the yes/no value to unchecked as well:
	var existingBMRBRef = document.getElementsByName("fromExistingBMRB");
	if( existingBMRBRef ) {
	  var existingBMRBVal = '';
	  for( var i = 0 ; i < existingBMRBRef.length ; ++i ) {
	    if( existingBMRBRef[i].value == "no" ) {
	      existingBMRBRef[i].checked = true;
	    } else {
	      existingBMRBRef[i].checked = false;
	    }
	  }
	}
      }
    }
  }
  return true;
}

// Make the number field appear when the "existing BMRB" field is checked.
function existingBMRBRefHack()
{
  var existingBMRBRef = document.getElementsByName("fromExistingBMRB");
  if( existingBMRBRef ) {
    var existingBMRBVal = '';
    // Because it's a radio button we have to get the value this way
    // in Javascript:
    for( var i = 0 ; i < existingBMRBRef.length ; ++i ) {
      if( existingBMRBRef[i].checked ) {
	existingBMRBVal = existingBMRBRef[i].value;
      }
    }
    var existingBMRBNumberRef = getRef( "fromExistingBMRBNumberDiv" );
    if( existingBMRBVal == "yes" ) {
      if( existingBMRBNumberRef ) {
	existingBMRBNumberRef.style.display = 'block';
      }
    } else {
      if( existingBMRBNumberRef ) {
	existingBMRBNumberRef.style.display = 'none';
      }
    }
  }
}

function validateNumberOnly(field)
{
  var msgDiv = getRef("intOnlyErrorDiv");
  var inpVal = parseInt(field.value, 10);
  if (isNaN(inpVal)) {
    field.value = "0" ;
    if( msgDiv )  {
      msgDiv.style.display = "inline";
    }
  } else {
    if( msgDiv )  {
      msgDiv.style.display = "none";
    }
  }
}
