<?php
/*
header( "Content-Type: text/plain" );
foreach( array_keys( $_GET ) as $param ) echo "$param => $_GET[$param]\n";
*/
if( (! isset( $_GET["filename"] )) || (strlen( trim( $_GET["filename"] ) ) < 1) ) {
    echo "Missing filename\n";
    exit;
}
echo $_GET["filename"] . "\n";
$filename = realpath( $_GET["filename"] );
//
// simple stupid catch: adit-nmr sessions are always in .../adit/sessions/bmrb-adit/...
// (realpath() expands all symlinks, ".", and "..")
//
if( strpos( $filename, "/adit/sessions/bmrb-adit/" ) === FALSE ) {
    echo "Invalid filename\n";
    exit;
}

if( ! file_exists( $filename ) ) {
    echo "File not found\n";
    exit;
}

header( "Content-Description: File Transfer" );
header( "Content-Type: application/octet-stream" );
header( "Content-Disposition: attachment; filename=" . basename( $filename ) );
header( "Content-Transfer-Encoding: binary" );
header( "Expires: 0" );
header( "Cache-Control: must-revalidate, post-check=0, pre-check=0" );
header( "Pragma: public" );
header( "Content-Length: " . filesize( $filename ) );
ob_clean();
flush();
readfile( $filename );
exit;

?>
