<!-- Instructions for first time users of ADIT_NMR  --> 
<?php
   
   $showFull = $_SERVER['QUERY_STRING'];
   $thing = explode("&", $showFull);

   if( $thing[0] != $thing[1] ) {
	$thisChoice = $thing[0];
   	$prevChoice = $thing[1];
   } else {
   	$prevChoice = '';
   	$thisChoice = '';
   }
   
 	
?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" 
   "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
   <HEAD>
      <TITLE>Overview of ADIT-NMR</TITLE>
      <link REL="stylesheet" TYPE="text/css" HREF="main.css" TITLE="main stylesheet">
   </HEAD>

  <BODY>
   <CENTER> 
   <?php include 'includes/xmenu.html' ?>

      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" ALIGN="LEFT" VALIGN="TOP" MARGIN="0">  <!-- layout table -->
      <!-- This is a two column table. It displays a side column menu and the main page -->
	 <TR>
            <TD class="sidemenuCol">
	       <?php include 'includes/deposit_menu.html' ?>
	    </TD>


	    <TD>
	       <TABLE class="content"  BORDER="0" CELLPADDING="0" CELLSPACING="0" ALIGN="LEFT" VALIGN="TOP" MARGIN="0">  <!-- content table -->
		  <TR class="titleAndIcon">  
		       <TD class="topContentTitle"> 
        		  <H1>Overview of ADIT-NMR</H1>
		       </TD>
		<!--       <TD class="topContentIcon">
			 <IMG SRC="images/logo.gif" ALT="BMRB Logo">
		       </TD> -->
		  </TR>

		<!-- ##################### page specific ####################### -->
		<TR><TD>
<?php /* echo "$showFull <BR> thisChoice = $thisChoice <BR> prevChoice = $prevChoice <BR>
               thing[0] = $thing[0] <BR> thing[1] = $thing[1]; <BR>"; */ ?>

    <H3>Instructions for first-time users of ADIT-NMR</H3>
<!--    <A HREF="/cgi-bin/aditnmr.cgi" TARGET="_blank">ADIT_NMR</A></H3> -->
    



    <H4><A class="noChange" HREF=<?php echo "\"adit_overview.php?preflight&$thisChoice\""; ?>>Before You Start</A></H4>
    <?php if( $thisChoice == 'preflight'&& $prevChoice != 'preflight' ):  ?>
    <P>Before proceeding with your deposition, it will be useful to have on hand the 
    following information:
	<UL>
	<LI>Chemical description of the molecules in the system studied.
		<UL>
		<LI>Residue sequences for polymers
		<LI>Sequence database reference for the biological molecule(s)
		<LI>Atom and bond lists for ligands and non-standard residues
		</UL>
	<LI>List of contents for at least a representative sample
	<LI>List of experimental conditions (temperature, pH, etc)
	<LI>A list of names to use for each sample and each set of experiemental conditions
	<LI>ASCII file(s) containing chemical shift assignments or coupling 
		constants, preferably in NMR-STAR format, but ASCII files containing tables with
		tab or comma delimited fields will be accepted.
		<ul>
		    <li>To create NMR-STAR data tables, please refer to the 
		         <A HREF="http://www.bmrb.wisc.edu/software/tablegen/" TARGET="_blank">BMRB data table generators</A></LI>
		    <li>To convert data files to NMR-STAR, please use 
		        <A HREF="http://www.bmrb.wisc.edu/software/starch/" TARGET="_blank">STARch file converter</A></LI>
   		    <LI>To submit additional or corrected assignments for an existing BMRB entry,
   		        please send them as e-mail attachment to BMRB annotators:
   		        <A HREF="mailto:annotators@bmrb.wisc.edu">annotators@bmrb.wisc.edu</A>, or
   		        to BMRB help alias: 
   		        <A HREF="mailto:bmrbhelp@bmrb.wisc.edu">bmrbhelp@bmrb.wisc.edu</A></LI>
		</UL>
	</UL>
    </P>
    <P>NMR-STAR, the data exchange format used by BMRB, is a flexible version of the CIF format used by PDB.
    A full description of the NMR-STAR format is available from the 
    <a href ="/formats.html" TARGET="_blank">BMRB web site</a>.
    Data entered here will be converted by software into the NMR-STAR format.
    </P>
    <?php endif  ?>
 




     <H4><A class="noChange" HREF=<?php echo "\"adit_overview.php?help&$thisChoice\""; ?>>ADIT Help</A></H4>
    <?php if( $thisChoice == 'help' && $prevChoice != 'help' ):  ?>
     <P>There is a link to an example and a help description associated with each entry field. 
	  This will show up in the frame below the main entry page. Though there is help available 
	  for most of the entry fields, there are still quite a few that don't have it. This is
	  being addressed. If you have an insurmountable problem with any entry field, please contact
	  <A HREF="mailto:bmrbhelp@bmrb.wisc.edu">BMRB Help</A>.
     </P>
    <?php endif  ?>





    <H4><A class="noChange" HREF=<?php echo "\"adit_overview.php?createSession&$thisChoice\""; ?>>Creating a Session</A></H4>
    <?php if( $thisChoice == 'createSession' && $prevChoice != 'createSession' ):  ?>
		   
	<IMG SRC="images/ADIT_start.png"  WIDTH="50%"  ALIGN="RIGHT"  BORDER="1" ALT="ADIT Start Page">

	<P>This is the first page you see when you go to ADIT-NMR.</P>
	
	<P> At the top lefthand part of the page 
	there are links to the <A HREF="http://www.rcsb.org/pdb/">Protein Data Bank (PDB)</A> and the BMRB homepage.
	These are also at the top right-hand side of the page, along with a link to another
	<A HREF="/bmrb-adit/docs/tutorial.html">ADIT-NMR tutorial</A> and a way to contact the BMRB.
	</P> 

    <P>The introductory page has two options for starting an editing session: 'Begin' a new session and 'Continue
    Session' from one you've already started. The latter requires a Restart ID, which can only be obtained by starting a new session.
	</P>
	
    <P>ADIT-NMR assigns you a Restart ID that consists of a combination 
    of your computer's network identity and a unique identification number. This 
    Restart ID will appear on your browser's title bar. There is a 'copy and pastable' Restart ID
	on the <A class="noChange" href=" <?php echo $_SERVER["PHP_SEFL"] ?> ?uploadData&createSession">'Deposit Data Files'</A> page 
	and on the 'Help' page,
	but we will talk about that later.
    </P>
    
    <P>The pull-down menu in the new session box labels the deposition as a protein,
    nucleic acid, or protein/nucleic acid combination. It is not absolutely necessary to mark
    this correctly, since a more complete choice of system type will be presented in the 
    deposition.
    </P>
    
    <P>Once you have a Restart ID, you can use it to recall that session at any time in 
    the future as long as the session hasn't been deposited. This allows you to begin a session,
    quit at any time, and come back to it in the future. There is no explicit logout procedure from
    ADIT-NMR. You can leave the site or close the browser at any time. As long as you have saved 
    the Restart ID, you can get back to it.
    </P>
    
    <P>If you've lost your Restart ID, contact
    <A HREF="mailto:bmrbhelp@bmrb.wisc.edu">bmrb help</A>, or call (608) 263-3291 for 
    phone support.</P>
    
    <P>If you've already deposited a session but have additional data to add to it, or need to 
    make changes in existing data, you can use the third deposition option and create a new 
    session from your previous session with the Restart ID. This is also convenient if your
	group needs to make multiple depositions that have common information - author names, for 
	instance.
    </P>
     <?php endif  ?>
   





    <H4><A class="noChange" HREF=<?php echo "\"adit_overview.php?enterData&$thisChoice\""; ?>>Entering Data</A></H4>
    <?php if( $thisChoice == 'enterData' && $prevChoice != 'enterData' ):  ?>

	
    <IMG SRC="images/entry_interview.png"  WIDTH="50%" ALIGN="RIGHT"  BORDER="1" ALT="ADIT Entry Interview">

    <P>Once you've created a session, the layout of  ADIT-NMR will be like this. It is  
    divided into four frames. The top frame contains links to the PDB, BMRB, the data file
	upload page, a preview page and the deposit page where you make your final submission.
    </P>
	
	<P>Pressing the 'Help' button at the top of the page will load a quick reference into 
	the main frame. It displays your Restart ID in a form that you can copy and paste into
	a text file on your computer so that you can restart later. There is also a help hypertext
	link next to each data entry field. Selecting this will display a short description
	of the field in frame at the bottom of the page.
	</P>
	
	<P>There is also an 'Example' hypertext link next to each field. This will display an
	example in the bottom frame. Becuase of the number of possible fields that ADIT is 
	designed to handle, not all of the help and example texts have been finished. If there
	is some data field that you feel is important but is not clearly explained, contact
	<A HREF="mailto:bmrbhelp@bmrb.wisc.edu">bmrb help</A>.
	</P>
	
	<P>The frame on the left-hand side of the page contains a list of the data categories 
	that are relevant to your entry. The size of this list will depend on the choices you make
	in the 'Entry Interview'. 'Entry Interview' is the first category that is displayed after
	you create a session.
	</P>
	
	<P>Any category that contains mandatory fields that must be completed in order to complete
	the entry is marked with a red exclamation point (<B><FONT COLOR="RED">!</FONT></B>). When all 
	mandatory fields in a particular category are complete, the red exclamation point is 
	replaced by a green check mark. 
	</P>
	
    <P>Within any given category a mandatory data field will hav a red asterisk (<B><FONT COLOR="RED">*</FONT></B>)
	next to it.
    </P>
	
	<P>Changes do not take effect until you <B>press the save button</B>.
	</P>
      <?php endif  ?>
  





    <H4><A class="noChange" HREF=<?php echo "\"adit_overview.php?uploadData&$thisChoice\""; ?>>Depositing Experimental Data Files</A></H4>
    <?php if( $thisChoice == 'uploadData' && $prevChoice != 'uploadData' ):  ?>

    <IMG SRC="images/deposit_1.png" ALIGN="RIGHT"  WIDTH="60%" BORDER="1" ALT="ADIT Deposit Page">
	
    <P>This is what you will see when you go to the 'Deposit Data File' page. Notice that the
	Restart ID is at the top of the page. You can get to this page from both the category list and 
	a button in the title frame.
	Press the 'Browse' button to search for the desired file on your computer and then press
	the 'Send file' button to upload it. You can only select one file at a time.
	</P>
	
	<P>We will be able to process your deposition more efficiently if you use the 
	pulldown menus in the 'Kind of Data' and 'File Syntax' fields to give us some
	information about your file. If you choose 'NMR STAR 3.0' as the file's syntax,
	ADIT will pre-process it as it is uploading. Otherwise, the file will be processed
	afterward. 
	</P>
	
	<P>Once your file has been deposited, its data <B>will not appear</B> in other ADIT
	windows or previews. The data is reviewed and processed by BMRB annotators before 
	it is integrated with the meta-data.
	</P>
	
	
	<P>	BMRB uses the Self-defining Text Archival and Retrieval (STAR) format (developed by 
	<A HREF="http://www.bmrb.wisc.edu/dictionary/htmldocs/nmr_star/dictionary_files/star_references2.html">Hall and Spadiaccini</A>)
	for all NMR data stored there. 
	There are <A HREF="http://www.bmrb.wisc.edu/tools/">tools</A> on the BMRB
    website to help you format your data in this format. In particular, 
    <A HREF="http://www.bmrb.wisc.edu/software/starch/">STARch</A> will convert data files between several
    common NMR data formats and the STAR format.
    </P>
	
	<P>It is not absolutely necessary to have your data in NMR-STAR format before you deposit
	it, but it is <B>very helpful</B>.
	</P>
	
     <?php endif  ?>
    
    





    <H4><A class="noChange" HREF=<?php echo "\"adit_overview.php?previewAndDeposit&$thisChoice\""; ?>>Previewing and Depositing your entry</A></H4>
    <?php if( $thisChoice == 'previewAndDeposit' && $prevChoice != 'previewAndDeposit' ):  ?>

    <IMG SRC="images/prev_dep_help_menu.png" ALIGN="RIGHT"  WIDTH="35%" BORDER="0" ALT="Preview, Deposit, Upload, and Help">

    <P>On the top frame there is a panel that links to five primary parts of the deposition process:</P>
	
	<UL>
		<LI>DEPOSITION HOME - reloads your session and returns you to 'Entry Interview'</LI>
		<LI>HELP - displays a list of basic ADIT functionality</LI>
		<LI>PREVIEW - displays all data tag labels and their associated data</LI>
		<LI>DEPOSIT - displays all data tag labels and their associated data and provides a
			button for submitting your entry if it is complete.</LI>
	</UL>
   
    
    <P>The Preview Entry displays all data tag labels and their associated data in a table. 
	
    </P>
     <?php endif  ?>



    





    <H4><A class="noChange" HREF=<?php echo "\"adit_overview.php?conversion&$thisChoice\""; ?>>Data conversion and help tools</A></H4>
    <?php if( $thisChoice == 'conversion' && $prevChoice != 'conversion' ):  ?>
    <P>BMRB provides a host of <A HREF="http://www.bmrb.wisc.edu/tools/index.html#Formatting">tools</A> to validate and 
    format your data, as well as <A HREF="http://www.bmrb.wisc.edu/tools/index.html#Formatting">data template generators</A>
    and <A HREF="http://www.bmrb.wisc.edu/tools/index.html#Formatting">data conversion tools</A>. </P>

     <P>BMRB also provides <A HREF="http://www.bmrb.wisc.edu/referenc/">biochemical reference</A> information.</P>
     <?php endif  ?>
	
    <BR>
    <P>If you have any questions or comments, <A HREF="mailto:bmrbhelp@bmrb.wisc.edu">please contact us</A>.</P>
		<!-- ########################################################### -->
		</TD></TR>
	     </TABLE>   <!-- END  content table -->
	    </TD>
       </TR>
       
    <?php include 'includes/footer.html' ?>
     </TABLE>  <!-- END  layout table -->
  
  </CENTER>
  </BODY>
</HTML>
