
var isDOM = (document.getElementById ? true : false);
var isIE4 = ((document.all && !isDOM) ? true : false);
var isNS4 = (document.layers ? true : false);
var isDyn = (isDOM || isIE4 || isNS4);

var deleteSubmit = false;

function getPersistentRef(id)
{
  trace('getPersistentRef:begin');
  if (isDOM) return top.control.document.getElementById(id);
  if (isIE4) return top.control.document.all[id];
  if (isNS4) return top.control.document.layers[id];
  trace('getPersistentRef:end - never reached');
}
function getRef(id)
{
  trace('getRef:begin');
  if (isDOM) return document.getElementById(id);
  if (isIE4) return document.all[id];
  if (isNS4) return document.layers[id];
  trace('getRef:end - never reached');
}
function getRefFromFrame(frameRef, id)
{
  trace('getRefFromFrame:begin');
  if( frameRef != null ) {
    if (isDOM) return frameRef.document.getElementById(id);
    if (isIE4) return frameRef.document.all[id];
    if (isNS4) return frameRef.document.layers[id];
  }
  trace('getRefFromFrame:end - never reached');
}


var global_TracingOn = false; // Set to true to enable debug tracing 
function trace( msg ){
 if( global_TracingOn ) {
  if( typeof( jsTrace ) != 'undefined' ){
    jsTrace.send( msg );
  }
  else{
    alert( msg );
  }
 }
}

// Workaround for a bug on Safari on Mac.  This will
// terminate any previously open socket by using it
// for an AJAX request that gets a dummy zero byte file.
// The zero byte file mentioned ("macFixDummy") has to exist
// on the server so it can be retrived without error.
// That stops the Mac problem of file uploads only working
// on every-other attempt.  To implement this, call this
// function as an onsubmit='....' function on the submit
// button of the upload form.  That makes it run this just
// prior to doing the upload:
// -------------------------------------------------------
function preventBrokenMacFileUpload() {
  if( /AppleWebKit|MSIE/.test(navigator.userAgent) ) {
    var xmlhttp;
    if( window.XMLHttpRequest ) {
      xmlhttp = new XMLHttpRequest();
    } else {
      // For IE5 and IE6 crappy browsers:
      xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
    xmlhttp.open( "GET", "bmrb-adit/MacFixClose", false ); // syncrhonous, so it blocks.
    xmlhttp.send();
  }
  return true;
}

  // For updating most form input fields, this
  // function works (except for selects):
  function selectMoveToField( selfWidget, widget ) {
    trace( 'Inside selectMoveToField: Begin\n' );  
    if( widget != null ) {
      widget.value = "?";
      widget.value = selfWidget.options[selfWidget.selectedIndex].value;
      if( widget.value == "" ) { 
        widget.value = selfWidget.options[selfWidget.selectedIndex].text;
      }
    }
  }
  trace( 'Inside selectMoveToField: End\n' );  

  // For updating a select list, you have to use
  // this function:
  function fieldCopyToSelect( checkLabelToo, oldVal, widget, newVal ) {
    trace( 'Inside fieldCopyToSelect: Begin\n' );  
    var i = 0;
    var widgetText = "";
    var newValFound = 0;
    widget.selectedIndex = 0 // default if nothing found
    for( i=0 ; i < widget.options.length ; i++ ) {
      widgetText = widget.options[i].value;
      if( widgetText == "" ) {
        widgetText = widget.options[i].Text;
      }
      if( widgetText.toLowerCase == newVal.toLowerCase ) {
        newValFound = 1;
        break;
      }
      if( widgetText == "?" && newValFound == 0 ) {
        widget.selectedIndex = i;
      }
    }
    if( checkLabelToo ) {
      validateLabel( widget, oldVal );
    }
    trace( 'Inside fieldCopyToSelect: End\n' );  
  }

// Find position of HTML element (el) 
function FindPosition(el){ 
 if(el.offsetParent){ 
  var inner_width = el.offsetWidth; 
  var inner_height = el.offsetHeight; 
  for( var posX=0, posY=0; 
       el.offsetParent; 
       el=el.offsetParent ) 
  { 
    posX+=el.offsetLeft; 
    posY+=el.offsetTop; 
  } 
  endX = posX + inner_width;
  endY = posY + inner_height;
  return [ posX, posY, endX, endY ]; 
 } 
 else 
  return [ el.x, el.y, el.x+el.width, el.y+el.height ]; 
} 
 
var contactHttpRequest;
var ajaxRequestURL = "http://" +  window.location.host + "/cgi-bin/bmrb-adit/get-live-data";

var progressBarPositive = true;

var pollIntervalID;
var barRequest;
var ufid_from_url;
function uploadProgressStartPolling( ufid, milliseconds )
{
  ufid_from_url = ufid;
  percentPrintInitialHTML( "uploadProgressID", "Progress Bar", 40, "#eedd99", "green" );
  pollIntervalID = window.setInterval( 'askProgressFromAJAX( "' + ufid +'" )', milliseconds  );
}
function uploadProgressStopPolling()
{
  window.clearInterval(pollIntervalID);
}

function askProgressFromAJAX( ufid )
{
  barRequest = HttpRequestBrowserIndependant( );
  if (!barRequest) {
    alert('Cannot create an XMLHTTP instance.');
    return false;
  }

  barRequest.open('GET',
		    ajaxRequestURL + "?ufid=" + ufid + "&" + "queryType=progress_bar",
		      true);
  barRequest.onreadystatechange = function() { respondToProgressFromAJAX(); };
  barRequest.send('');
}

function respondToProgressFromAJAX( )
{

  if( barRequest.readyState == 4 ) {
    if( barRequest.status == 200 ) {
      var xmlDoc = barRequest.responseXML.documentElement;
      if( xmlDoc ) {
	var legend;
	var value;
	legend = xmlDoc.getElementsByTagName( "legend" )[0].childNodes[0].nodeValue;
	percentBarNewVal( "uploadProgressID", legend, value );
	value  = parseInt( xmlDoc.getElementsByTagName( "value"  )[0].childNodes[0].nodeValue );
	percentBarNewVal( "uploadProgressID", legend, value );
	if( legend == "?" || legend == "." ) { legend = ""; }
	if( value == "?" || value == "." ) { value = 0; }

	percentBarNewVal( "uploadProgressID", legend, value );
	progressBarPositive = (value >= 0);
      }
    } else {
      alert( 'Error with HTTPRequest: readyState = ' +
	      contactHttpRequest.readyState + 
	      ', status = ' + 
	      contactHttpRequest.status );
      return false;
    }
  }
}



// Prints the starting HTML text to define a percent bar - call this
// javascript right inside the HTML page at the point you want the
// percentage bar to appear.  DO NOT call it after the page is done
// loading  - that would make it start a new page.
function percentPrintInitialHTML( barID, /* Give it an id string that's unique,
					    so the program can refer to it */
                                  label,  /* HTML text to appear next to the progress bar */
                                  width,  /* Given in em's, not pixels */
				  bgColor, 
				  fgColor  /* Color to draw as it fills in */
				  /* (BG color is transparent) */
                                  )
{
  document.write( "<!-- Progress Bar Widget -->\n" );
  document.write( "<div id='" + barID + "_box' " + 
                  "style='display:block; position:absolute left:100px; top:50px; " +
		         "border-style:solid; border-width:2px; border-color:black; background-color: " + bgColor + "; " +
			 "width: " + width + "em;' >\n" );
  document.write( "  <div id='" + barID + "_label" + "'>\n" );
  document.write( "    " + label + "<br/>\n" );
  document.write( "  </div>\n" );
  document.write( "      <div id='" + barID + "'\n" +
                  "         style='display:block; " +
                                  "height:1em; " +
				  "width:0em; " +
				  "background-color: " + fgColor + "; " +
				  "'\n" +
		  "         fullWidth='" + width + "'\n" +
		  "      >\n" +
                  "        &nbsp;\n" );
  document.write( "      </div>\n" );
  document.write( "    </div>\n" );
  document.write( "</div>\n" );
}

function percentBarNewVal( barID, label, percent ) 
{
  var theBoxDiv = getRef( barID + "_box" );
  var theBarDiv = getRef( barID );
  var theLabelDiv = getRef( barID + "_label" );
  if( theLabelDiv != null ) {
    var sib = theLabelDiv.firstChild;
    while( sib ) {
      if( sib.nodeType == 3 ) {
        sib.data = label;;
	break;
      } else {
	sib = sib.nextSibling;
      }
    }
    if( theLabelDiv) {
    }
  }
  if( percent < 0 ) {
    if( theBoxDiv != null ) {
      theBoxDiv.style.display="none";
      uploadProgressStopPolling();
    }
  } else {
    if( ! progressBarPositive ) {
      uploadProgressStopPolling();
      uploadProgressStartPolling( ufid_from_url, 2000); /* every 2 seconds now */
    }
    if( theBoxDiv != null ) {
      theBoxDiv.style.display="block";
    }
    if( theBarDiv != null ) {
      fullWidth = theBarDiv.getAttribute( "fullWidth" );
      if( fullWidth != null ) {
	curWidth = ( fullWidth * (percent/100.0) ) ;
	theBarDiv.style.width = curWidth + "em";
      }
    }
    
  }
}

function HttpRequestBrowserIndependant()
{
  var returnHTTPRequest;

  if (window.XMLHttpRequest) { // Sane browsers
      returnHTTPRequest = new XMLHttpRequest();
      if( ! returnHTTPRequest ) {
	alert( 'javascript error trying to get new XMLHttpRequest object' );
      }
      if (returnHTTPRequest.overrideMimeType) {
	  returnHTTPRequest.overrideMimeType('text/xml');
	  // use text/html or text/xml for most applications.
      }
  } 
  else if (window.ActiveXObject) { // IE
    try {
      returnHTTPRequest = new ActiveXObject("Msxml2.XMLHTTP");
    } 
    catch (e) {
      try {
	returnHTTPRequest = new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e) {
      }
    }
  }
  return returnHTTPRequest;
}
